/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.51 from the
 * contents of Async.xs. Do not edit this file, edit Async.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "Async.xs"
#include "xthread.h"

#include <errno.h>

#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#include <stddef.h>

#include "EVAPI.h"

/* our userdata */
typedef struct {
  xmutex_t lock; /* global loop lock */
  void (*signal_func) (void *signal_arg, int value);
  void *signal_arg;
  ev_async async_w;
  xthread_t tid;
  unsigned int max_loops;
  unsigned int count;

  xcond_t invoke_cv;

  SV *interrupt;
#if defined(_WIN32) && defined(USE_ITHREADS)
  void *thx;
#endif
} udat;

static void loop_set_cb (EV_P);

static void
fg_invoke_pending (EV_P)
{
  udat *u = ev_userdata (EV_A);

  u->count = ev_pending_count (EV_A);

  if (u->count)
    ev_invoke_pending (EV_A);
}

static void
c_func (pTHX_ void *loop_, int value)
{
  struct ev_loop *loop = (struct ev_loop *)loop_;
  udat *u = ev_userdata (EV_A);
  int i;

  X_LOCK (u->lock);
  ev_invoke_pending (EV_A);

  /* do any additional foreground loop runs */
  for (i = u->max_loops; i--; )
    {
      /* this is a bit tricky, but we can manage... */
      u->count = 0;

      ev_set_invoke_pending_cb (EV_A, fg_invoke_pending);
      ev_set_loop_release_cb (EV_A, 0, 0);
      ev_run (EV_A, EVRUN_NOWAIT);
      loop_set_cb (EV_A);

      if (!u->count)
        break;
    }

  X_COND_SIGNAL (u->invoke_cv);
  X_UNLOCK (u->lock);
}

static void
async_cb (EV_P_ ev_async *w, int revents)
{
  /* just used for the side effects */
}

static void
l_release (EV_P)
{
  udat *u = ev_userdata (EV_A);
  X_UNLOCK (u->lock);
}

static void
l_acquire (EV_P)
{
  udat *u = ev_userdata (EV_A);
  X_LOCK (u->lock);
}

static void
l_invoke (EV_P)
{
  udat *u = ev_userdata (EV_A);

  while (ev_pending_count (EV_A))
    {
      u->signal_func (u->signal_arg, 1);
      X_COND_WAIT (u->invoke_cv, u->lock);
    }
}

static void
loop_set_cb (EV_P)
{
  ev_set_invoke_pending_cb (EV_A, l_invoke);
  ev_set_loop_release_cb (EV_A, l_release, l_acquire);
}

X_THREAD_PROC(l_run)
{
  struct ev_loop *loop = (struct ev_loop *)thr_arg;
#if defined(_WIN32) && defined(USE_ITHREADS)
  udat *u = ev_userdata (EV_A);

  /* just setting the same context pointer as the other thread is */
  /* probably fatal, yet, I have no clue what makes libev crash (malloc?) */
  /* as visual c also crashes when it tries to debug the crash */
  /* the loser platform is indeed a crashy OS */
  PERL_SET_CONTEXT (u->thx);
#endif

  l_acquire (EV_A);

  /* yeah */
  pthread_setcanceltype (PTHREAD_CANCEL_ASYNCHRONOUS, 0);

  ev_ref (EV_A);
  ev_run (EV_A, 0);
  ev_unref (EV_A);

  l_release (EV_A);

  return 0;
}

static void
scope_lock_cb (pTHX_ void *loop_)
{
  struct ev_loop *loop = (struct ev_loop *)SvIVX ((SV *)loop_);
  udat *u = ev_userdata (EV_A);

  X_UNLOCK (u->lock);
  SvREFCNT_dec ((SV *)loop_);
}

#line 159 "Async.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 303 "Async.c"

XS_EUPXS(XS_EV__Loop__Async__c_func); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_EV__Loop__Async__c_func)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "loop");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	loop = ST(0)
;
#line 162 "Async.xs"
        EXTEND (SP, 2);
        PUSHs (sv_2mortal (newSViv (PTR2IV (c_func))));
        PUSHs (sv_2mortal (newSViv (SvIVX (SvRV (loop)))));
#line 320 "Async.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_EV__Loop__Async__attach); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_EV__Loop__Async__attach)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "loop_, interrupt, sig_func, sig_arg");
    {
	SV *	loop_ = ST(0)
;
	SV *	interrupt = ST(1)
;
	IV	sig_func = (IV)SvIV(ST(2))
;
	void *	sig_arg = INT2PTR(void *,SvIV(ST(3)))
;
#line 170 "Async.xs"
{
  	pthread_mutexattr_t ma;
	struct ev_loop *loop = (struct ev_loop *)SvIVX (SvRV (loop_));
  	udat *u;

        Newz (0, u, 1, udat);
        u->interrupt   = newSVsv (interrupt);
        u->signal_func = (void (*)(void *, int))sig_func;
        u->signal_arg  = sig_arg;
#if defined(_WIN32) && defined(USE_ITHREADS)
        u->thx         = PERL_GET_CONTEXT;
#endif

        ev_async_init (&u->async_w, async_cb);
        ev_async_start (EV_A, &u->async_w);

        pthread_mutexattr_init (&ma);
#ifdef PTHREAD_MUTEX_RECURSIVE
        pthread_mutexattr_settype (&ma, PTHREAD_MUTEX_RECURSIVE);
#else
        pthread_mutexattr_settype (&ma, PTHREAD_MUTEX_RECURSIVE_NP);
#endif
        pthread_mutex_init (&u->lock, &ma);
        pthread_mutexattr_destroy (&ma);

        pthread_cond_init (&u->invoke_cv, 0);

        ev_set_userdata (EV_A, u);
        loop_set_cb (EV_A);

        thread_create (&u->tid, l_run, loop);
}
#line 375 "Async.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_EV__Loop__Async_interrupt); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_EV__Loop__Async_interrupt)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "loop_");
    {
	SV *	RETVAL;
	SV *	loop_ = ST(0)
;
#line 206 "Async.xs"
{
	struct ev_loop *loop = (struct ev_loop *)SvIVX (SvRV (loop_));
  	udat *u = ev_userdata (EV_A);

        RETVAL = newSVsv (u->interrupt);
}
#line 398 "Async.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_EV__Loop__Async_set_max_foreground_loops); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_EV__Loop__Async_set_max_foreground_loops)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "loop_, max_loops");
    {
	SV *	loop_ = ST(0)
;
	UV	max_loops = (UV)SvUV(ST(1))
;
#line 218 "Async.xs"
{
	struct ev_loop *loop = (struct ev_loop *)SvIVX (SvRV (loop_));
  	udat *u = ev_userdata (EV_A);

        u->max_loops = max_loops;
}
#line 424 "Async.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_EV__Loop__Async_lock); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_EV__Loop__Async_lock)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items != 1)
       croak_xs_usage(cv,  "loop_");
    {
	SV *	loop_ = ST(0)
;
#line 232 "Async.xs"
{
	struct ev_loop *loop = (struct ev_loop *)SvIVX (SvRV (loop_));
  	udat *u = ev_userdata (EV_A);

        switch (ix)
          {
            case 0: X_LOCK   (u->lock); break;
            case 1: X_UNLOCK (u->lock); break;
            case 2: ev_async_send (EV_A, &u->async_w); break;
          }
}
#line 452 "Async.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_EV__Loop__Async_scope_lock); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_EV__Loop__Async_scope_lock)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "loop_");
    {
	SV *	loop_ = ST(0)
;
#line 247 "Async.xs"
{
	struct ev_loop *loop = (struct ev_loop *)SvIVX (SvRV (loop_));
  	udat *u = ev_userdata (EV_A);

        X_LOCK (u->lock);

        LEAVE; /* unfortunately, perl sandwiches XS calls into ENTER/LEAVE */
        SAVEDESTRUCTOR_X (scope_lock_cb, (void *)SvREFCNT_inc (SvRV (loop_)));
        ENTER; /* unfortunately, perl sandwiches XS calls into ENTER/LEAVE */
}
#line 478 "Async.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_EV__Loop__Async_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_EV__Loop__Async_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "loop_");
    {
	SV *	loop_ = ST(0)
;
#line 261 "Async.xs"
{
	struct ev_loop *loop = (struct ev_loop *)SvIVX (SvRV (loop_));
  	udat *u = ev_userdata (EV_A);

        if (u)
          {
            X_LOCK (u->lock);
            ev_async_stop (EV_A, &u->async_w);
            /* now thread is around blocking call, or in pthread_cond_wait */
            pthread_cancel (u->tid);
            X_UNLOCK (u->lock);
            pthread_mutex_destroy (&u->lock);
            pthread_cond_destroy (&u->invoke_cv);
            SvREFCNT_dec (u->interrupt);
            Safefree (u);
          }
}
#line 511 "Async.c"
    }
    XSRETURN_EMPTY;
}

#ifdef __cplusplus
extern "C" {
#endif
XS_EXTERNAL(boot_EV__Loop__Async); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_EV__Loop__Async)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if PERL_VERSION_LE(5, 8, 999) /* PERL_VERSION_LT is 5.33+ */
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        (void)newXSproto_portable("EV::Loop::Async::_c_func", XS_EV__Loop__Async__c_func, file, "$");
        (void)newXSproto_portable("EV::Loop::Async::_attach", XS_EV__Loop__Async__attach, file, "@");
        (void)newXSproto_portable("EV::Loop::Async::interrupt", XS_EV__Loop__Async_interrupt, file, "$");
        (void)newXSproto_portable("EV::Loop::Async::set_max_foreground_loops", XS_EV__Loop__Async_set_max_foreground_loops, file, "$$");
        cv = newXSproto_portable("EV::Loop::Async::lock", XS_EV__Loop__Async_lock, file, "$");
        XSANY.any_i32 = 0;
        cv = newXSproto_portable("EV::Loop::Async::notify", XS_EV__Loop__Async_lock, file, "$");
        XSANY.any_i32 = 2;
        cv = newXSproto_portable("EV::Loop::Async::unlock", XS_EV__Loop__Async_lock, file, "$");
        XSANY.any_i32 = 1;
        (void)newXSproto_portable("EV::Loop::Async::scope_lock", XS_EV__Loop__Async_scope_lock, file, "$");
        (void)newXSproto_portable("EV::Loop::Async::DESTROY", XS_EV__Loop__Async_DESTROY, file, "$");

    /* Initialisation Section */

#line 154 "Async.xs"
{
	I_EV_API ("EV::Loop::Async");
        CvNODEBUG_on (get_cv ("EV::Loop::Async::scope_lock", 0)); /* otherwise calling scope can be the debugger */
}

#line 565 "Async.c"

    /* End of Initialisation Section */

#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

#ifdef __cplusplus
}
#endif
